/**
 * @date 2019年11月16日  
 * @author 翁东州
 * @方法中文名称:
 */
package cn.timer.api.dto.yggl;

import java.io.Serializable;
import java.util.Date;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

import com.alibaba.fastjson.annotation.JSONField;

import cn.timer.api.config.exception.Regular;
import cn.timer.api.config.exception.ValidationMsg;
import cn.timer.api.utils.Page;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @date 2019年11月16日  
 * @author 翁东州
 * @方法中文名称:
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class AddygdaDto extends Page implements Serializable{
	
	private static final long serialVersionUID = -1230023773946170942L;

	@NotBlank(message = ValidationMsg.NOTBLANK)
	@ApiModelProperty(value="员工姓名",example="华仔")
	private String name;

	@NotBlank(message = ValidationMsg.NOTBLANK)
	@Pattern(regexp=Regular.PHONE,message = ValidationMsg.PATTERN)
	@ApiModelProperty(value="手机号",example="101")
	private String phone;
	
	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value="证件类型 0:身份证;1:港澳居民来往内地通行证;2:台湾居民来往大陆通行证;3:外国护照;4:其他",example="0")
    private Integer zjType;
    
	@NotBlank(message = ValidationMsg.NOTBLANK)
	@ApiModelProperty(value="证件号码 ",example="证件号码")
    private String zjNum;
	
	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value="工作性质 0全职、1实习生、2兼职、3劳务派遣、4劳务、5派遣、6外包、7退休返聘",example="0")
    private Integer jobType;
	
//	@NotNull(message = ValidationMsg.NOTNULL)
	@JSONField(format="yyyy-MM-dd") 
	@ApiModelProperty(value="入职日期 ",example="客户注册后的时间为入职时间")
    private Date rzTime;
	
	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value="试用期 0:无试用期;1:1个月;2:2个月;3:3个月;4:4个月;5:5个月;6:6个月（有试用期显示选项）",example="0")
    private Integer syq;
	
	@NotNull(message = ValidationMsg.NOTNULL)
	@ApiModelProperty(value="性别 0：男；1：女",example="0")
    private Integer sex;
	
	@ApiModelProperty(value="部门岗位id",example="0")
    private Integer bmgwId;
	
	
}
