package cn.timer.api.utils.router.business;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONObject;
import cn.timer.api.controller.kqgl.service.KqglService;
import cn.timer.api.dto.kqmk.AttEvectionApprovalDto;
import cn.timer.api.dto.spmk.FromData;
import cn.timer.api.utils.DateUtil;
import lombok.Builder;

/**
 * 外出-业务
 * @author Tang
 *
 */
@Service
public class GoOutBusiness extends SpmkAssoBusiness {

	@Autowired
	private KqglService kqglService;
	
	@Override
	public void handleApprove(JSONObject jsonObj) throws Exception {
		// TODO Auto-generated method stub
		// 发起人企业id
		Integer orgCode = ObjectUtil.isNull(jsonObj.get("orgCode")) ? null : Convert.toInt(jsonObj.get("orgCode"));
		// 发起人id
		Integer id = jsonObj.getInt("id");
		
		// 审批汇总id
		String approveId = ObjectUtil.isNull(jsonObj.get("approveId",FromData.class)) ? null : jsonObj.get("approveId",FromData.class).getValue();
		// 开始时间
		String startTime = jsonObj.get("__startTime",FromData.class).getValue();
		// 结束时间
		String endTime = jsonObj.get("__endTime",FromData.class).getValue();
		// 时长
		String longTime = jsonObj.get("__longTime",FromData.class).getValue();
		// 出差事由
//		String businessTrip = jsonObj.get("__businessTrip",FromData.class).getValue();
		// 上传文件
//		String UploadAttachment = jsonObj.get("UploadAttachment",FromData.class).getValue();
		
		AttEvectionApprovalDto eaD = AttEvectionApprovalDto
				.builder()
				.userid(id)
				.orgcode(orgCode)
				.evectionid(Convert.toInt(approveId))
				.evectiontype(2)
				.starttime(DateUtil.getFormat(startTime))
				.endtime(DateUtil.getFormat(endTime))
				.duration(Convert.toDouble(longTime))
				.build();
				
		System.out.println("外出:" + eaD);
		// 调 考勤管理 业务-外出
		kqglService.attevectionapproval(eaD);
	}

}
